%define		pname jailkit
%define		pversion 2.15
%define 	bversion 115
%define		rpmrelease iworx

%define 	debug_package %{nil}

# INSTRUCTIONS!!! <--------------------- READ THEM!!!
#
# You can rebuild  this  package safely using Command 
# Line Overrides. For example, if you want to rebuild
# this package for RedHat just type:
# $ rpm --rebuild --with redhat package.src.rpm
# $ rpm -ba --with redhat package.spec
#
# mdk = GNU/Linux Mandrake
# rht = Linux Red-Hat
# sus = Suse Linux
# fdr = Fedora Linux
# cos = CentOS
# whb = White Box Linux
# rhe = Red Hat Enterprise
# unk = Unknown
#

%define		build_rhe_6x   0
%define		build_rhe_7x   0
%define		build_rhe_8x   0

%define		build_unk      1

# Command Line Overrides
%{?_with_rhe6x: 	%{expand: %%define build_rhe_6x   1}}
%{?_with_rhe7x: 	%{expand: %%define build_rhe_7x   1}}
%{?_with_rhe8x: 	%{expand: %%define build_rhe_8x   1}}

%{?_with_unk: 		%{expand: %%define build_unk      1}}

# Distro Statements
%if %{build_rhe_6x}
%define		oscode rhe6x
%define 	ostype RedHat Enterprise 6.x
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rhe_7x}
%define		oscode rhe7x
%define 	ostype RedHat Enterprise 7.x
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rhe_8x}
%define         oscode rhe8x
%define         ostype Almalinux 8.x
%define         ccflags %{optflags}
%define         ldflags %{optflags}
%define         build_unk 0
%endif

%define	release %{bversion}.%{oscode}.%{rpmrelease}

##
# THIS MUST BE LAST
##

%if %{build_unk}
%define		oscode unk
%define 	ostype Unknown Distribution
%define		release %{bversion}.%{rpmrelease}
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%endif

############### RPM ################################

Summary:	JailKit - Jail Helper
Name:		%{pname}
Version:	%{pversion}
Release: 	%{release}
License:	GPL

Group:		System Environment/Daemons
Source0:	%{name}-%{version}.tar.gz
URL:		http://olivier.sessink.nl/jailkit/

Distribution:	InterWorx-HAL
Vendor:         INTERWORX L.L.C.
Packager:	    Paul Oehler <poehler@interworx.com>

BuildRequires: python2

BuildRoot:	%{_tmppath}/%{name}-%{version}-root

#Source1:	jailkit-jk_init.ini

%description
Jailkit is a set of utilities to limit user accounts to specific files 
using chroot() and or specific commands. Setting up a chroot shell, a 
shell limited to some specific command, or a daemon inside a chroot jail 
is a lot easier using these utilities.

Jailkit has been in use for a while on CVS servers (in a chroot and 
limited to cvs), sftp/scp servers (both in a chroot and limited to 
sftp/scp as well as not in a chroot but only limited to sftp/scp), and 
also on general servers with accounts where the shell accounts are in a 
chroot.

%prep

[ -n %{buildroot} ] && rm -rf %{buildroot}

[ -d $RPM_BUILD_DIR/%{name}-%{pversion} ] && rm -rf $RPM_BUILD_DIR/%{name}-%{pversion}

%setup -q -n %{name}-%{version}

# Try detecting newest gcc (some distributions have got more then one compiler)
# and write it on a temp file 

[ -f %{_tmppath}/%{name}-%{pversion}-gcc ] && rm -f %{_tmppath}/%{name}-%{pversion}-gcc

if   [ -x /usr/bin/gcc-3.2.3 ]; then
	echo "/usr/bin/gcc-3.2.3" > %{_tmppath}/%{name}-%{pversion}-gcc
elif   [ -x /usr/bin/gcc-3.2.2 ]; then
	echo "/usr/bin/gcc-3.2.2" > %{_tmppath}/%{name}-%{pversion}-gcc
elif   [ -x /usr/bin/gcc-3.2.1 ]; then
	echo "/usr/bin/gcc-3.2.1" > %{_tmppath}/%{name}-%{pversion}-gcc
elif [ -x /usr/bin/gcc-3.2 ]; then
        echo "/usr/bin/gcc-3.2" > %{_tmppath}/%{name}-%{pversion}-gcc
elif [ -x /usr/bin/gcc-3.1.1 ]; then
        echo "/usr/bin/gcc-3.1.1" > %{_tmppath}/%{name}-%{pversion}-gcc
else
	echo "gcc" > %{_tmppath}/%{name}-%{pversion}-gcc
fi

# Display compilation flags and OS with colors ;)

[ -f %{_tmppath}/%{name}-%{pversion}-show_flags ] && rm -f %{_tmppath}/%{name}-%{pversion}-show_flags
cat <<EOF >>%{_tmppath}/%{name}-%{pversion}-show_flags
#!/bin/sh

RPM="RPM RELEASE: \033[40m\033[001;033m%{release}"
OS="OS TYPE IS : \033[40m\033[001;033m%{ostype}"
GCC="GCC IS     : \033[40m\033[001;033m`cat %{_tmppath}/%{name}-%{pversion}-gcc`"
CCF="CCFLAGS    : \033[40m\033[001;033m%{ccflags}"
LDF="LDFLAGS    : \033[40m\033[001;033m%{ldflags}"

echo
echo
echo -e "\033[40m\033[001;031m\$RPM\033[0m"
echo -e "\033[40m\033[001;031m\$OS\033[0m"
echo -e "\033[40m\033[001;031m\$GCC\033[0m"
echo -e "\033[40m\033[001;031m\$CCF\033[0m"
echo -e "\033[40m\033[001;031m\$LDF\033[0m"
echo
echo

sleep 3

EOF

# Take care to execute and then to delete
chmod u+x %{_tmppath}/%{name}-%{pversion}-show_flags
%{_tmppath}/%{name}-%{pversion}-show_flags
[ -f %{_tmppath}/%{name}-%{pversion}-show_flags ] && rm -f %{_tmppath}/%{name}-%{pversion}-show_flags

# We have gcc written in a temp file
export CC="`cat %{_tmppath}/%{name}-%{pversion}-gcc`"
export CFLAGS="%{ccflags}"
export LDFLAGS="%{ldflags}"

# Delete gcc temp file
[ -f %{_tmppath}/%{name}-%{pversion}-gcc ] && rm -f %{_tmppath}/%{name}-%{pversion}-gcc

%build

[ -n "%{buildroot}" -a "%{buildroot}" != / ] && rm -rf %{buildroot}

mkdir -p %{buildroot}

# Delete gcc temp file
[ -f %{_tmppath}/%{name}-%{pversion}-gcc ] && rm -f %{_tmppath}/%{name}-%{pversion}-gcc

export CPPFLAGS=""
export CFLAGS="$RPM_OPT_FLAGS -fomit-frame-pointer -fPIC $CPPFLAGS"
export PYTHONINTERPRETER="/usr/bin/python2"

./configure                               \
	--prefix=%{_prefix}               \
	--bindir=%{_bindir}               \
	--mandir=%{_mandir}               \
	--localstatedir=%{_localstatedir} \
	--libdir=%{_libdir}               \
	--datadir=%{_datadir}             \
	--includedir=%{_includedir}       \
	--sysconfdir=%{_sysconfdir}

%{__make} %{?_smp_mflags}

%install
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%{__make}                                            \
	prefix=%{buildroot}%{_prefix}                \
	iniprefix=%{buildroot}%{_sysconfdir}/jailkit \
	bindir=%{buildroot}%{_bindir}                \
	mandir=%{buildroot}%{_mandir}                \
	libdir=%{buildroot}%{_libdir}                \
	localstatedir=%{buildroot}%{_localstatedir}  \
	datadir=%{buildroot}%{_datadir}              \
	includedir=%{buildroot}%{_includedir}        \
	sysconfdir=%{buildroot}%{_sysconfdir}        \
	install

#cp -f %{SOURCE1} %{buildroot}%{_sysconfdir}/jailkit/jk_init.ini

if grep %{buildroot}%{_sbindir}/jk_chrootsh /etc/shells ; then \
	grep -v '%{buildroot}%{_sbindir}/jk_chrootsh' /etc/shells > /etc/shells.new
	mv -f /etc/shells.new /etc/shells
fi

%preun
if [ "$1" == "0" ]; then
   echo
   echo "WARNING: jailkit package removal request denied.  This package is required by Interworx."
   echo
   exit 1
fi

%post

if ! grep %{_sbindir}/jk_chrootsh /etc/shells > /dev/null ; then \
	echo %{_sbindir}/jk_chrootsh >> /etc/shells
fi

%postun

if [ "$1" == "0" ]; then
    if grep %{_sbindir}/jk_chrootsh /etc/shells > /dev/null ; then \
	    grep -v 'jk_chrootsh' /etc/shells > /etc/shells.new
	    mv -f /etc/shells.new /etc/shells
    fi
fi

%clean
[ -n "%{buildroot}" -a "%{buildroot}" != / ] && rm -rf %{buildroot}
[ -d $RPM_BUILD_DIR/%{name}-%{pversion} ] && rm -rf $RPM_BUILD_DIR/%{name}-%{pversion}

%files
%defattr(-,root,root)
%{_sbindir}/*
%{_bindir}/jk_uchroot
%{_sysconfdir}/jailkit/*
%{_mandir}/man8/jailkit*
%{_mandir}/man8/jk_*
%{_datadir}/jailkit/jk_*

%changelog
* Tue Aug 10 2021 Tim College <tcollege@interworx.com>
- Updated for Almalinux 8
- Remove code for EOL OS
* Tue Aug 26 2014 Matt Parmelee <mparmelee@interworx.com>
- Updated for RHEL 7.x
* Mon Jul 30 2012 Paul Oehler <poehler@interworx.com>
- Upgraded to 2.15
* Thu Oct 07 2010 Paul Oehler <poehler@interworx.com>
- Removed extraneous rpm output.
* Sun Oct 03 2010 Paul Oehler <poehler@interworx.com>
- Added uninstall blocker preun script
* Thu May 06 2010 Paul Oehler <poehler@interworx.com>
- Updated for RHEL 6.x
* Tue Jun 17 2008 Paul Oehler <poehler@interworx.com>
- Updated for Fedora 9
* Tue May 13 2008 Paul Oehler <poehler@interworx.com>
- added support for Fedora 8
* Sun May 1 2005 Chris Wells <clwells@nexcess.net>
- initial release
